
#ifndef __KNAPSACK_H
    #define __KNAPSACK_H

    #include<iostream>
    #include<vector>
    #include<string>

    namespace Knapsack
    {
    
        class Packet
        {
            public:
                std::string Name;
                int Weight;
                int Value;
        };

        class Instance
        {
            public:
                std::vector<Packet> Packets;
                int MaximumWeight;
                int size() const;
        };

        class Selection
        {
            public:
                Selection();
                
                std::vector<const Packet*> Choice;
                int Weight;
                int Value;
        };
        
        class Solver
        {
            protected:
                void Solve(const Instance& instance, int Depth, Selection& temp, Selection& result,
                           std::vector<int>& ReachableValues, std::vector<int>& CombinedWeights);

            public:
                Selection Solve(const Instance& instance);
        };
    }
    
#endif
