
#include <unistd.h>
#include "knapsack.h"
using namespace std;

int main(int argc, char** argv)
{
    // construct instance
    int PacketCount;
    if(isatty(0))
        cout << "Number of availiable packets > ";
    cin >> PacketCount;
    Knapsack::Instance instance;
    if(isatty(0))
        cout << "Maximum allowed weight       > ";
    cin >> instance.MaximumWeight;
    for(int i = 0; i < PacketCount; ++i)
    {
        Knapsack::Packet packet;
        if(isatty(0))
            cout << "Name of item number " << (i+1) << " > ";
        cin >> packet.Name;
        if(isatty(0))
            cout << "Value of " << packet.Name << " > ";
        cin >> packet.Value;
        if(isatty(0))
            cout << "Weight of " << packet.Name << " > ";
        cin >> packet.Weight;
        instance.Packets.push_back(packet);
    }

    
    // solve
    Knapsack::Solver solver;
    Knapsack::Selection solution = solver.Solve(instance);

    
    // print solution
    cout << (isatty(0) ? "\n" : "") << "Maximum value: " << solution.Value
         << "\nWeight:        " << solution.Weight
         << "\nChoice:\n";
    for(vector<const Knapsack::Packet*>::iterator i = solution.Choice.begin(); i != solution.Choice.end(); i++)
        cout << " - " << (*i)->Name << '\n';

    
    return(0);
}
